G_BEGIN_DECLS

typedef void (*emp_cli_channel_handler_callback_for_handle_channel) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_handler_call_handle_channel (gpointer proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    emp_cli_channel_handler_callback_for_handle_channel callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_handler_run_handle_channel (gpointer proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_signal_callback_receiving) (TpProxy *proxy,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_stream_engine_connect_to_receiving (gpointer proxy,
    emp_cli_stream_engine_signal_callback_receiving callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_stream_engine_signal_callback_stream_state_changed) (TpProxy *proxy,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    guint arg_state,
    guint arg_direction,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_stream_engine_connect_to_stream_state_changed (gpointer proxy,
    emp_cli_stream_engine_signal_callback_stream_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_stream_engine_callback_for_set_output_volume) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_set_output_volume (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_volume,
    emp_cli_stream_engine_callback_for_set_output_volume callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_set_output_volume (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_volume,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_mute_input) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_mute_input (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    emp_cli_stream_engine_callback_for_mute_input callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_mute_input (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_mute_output) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_mute_output (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    emp_cli_stream_engine_callback_for_mute_output callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_mute_output (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_set_output_window) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_set_output_window (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_window,
    emp_cli_stream_engine_callback_for_set_output_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_set_output_window (gpointer proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_window,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_add_preview_window) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_add_preview_window (gpointer proxy,
    gint timeout_ms,
    guint in_window,
    emp_cli_stream_engine_callback_for_add_preview_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_add_preview_window (gpointer proxy,
    gint timeout_ms,
    guint in_window,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_remove_preview_window) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_remove_preview_window (gpointer proxy,
    gint timeout_ms,
    guint in_window,
    emp_cli_stream_engine_callback_for_remove_preview_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_remove_preview_window (gpointer proxy,
    gint timeout_ms,
    guint in_window,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_stream_engine_callback_for_shutdown) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_stream_engine_call_shutdown (gpointer proxy,
    gint timeout_ms,
    emp_cli_stream_engine_callback_for_shutdown callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_stream_engine_run_shutdown (gpointer proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
