#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _emp_svc_channel_handler_object_info;

struct _EmpSvcChannelHandlerClass {
    GTypeInterface parent_class;
    emp_svc_channel_handler_handle_channel_impl handle_channel;
};

static void emp_svc_channel_handler_base_init (gpointer klass);

GType
emp_svc_channel_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelHandlerClass),
        emp_svc_channel_handler_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelHandler", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_handler_handle_channel_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel_Type: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * HandleChannel on interface org.freedesktop.Telepathy.ChannelHandler.
 */
static void
emp_svc_channel_handler_handle_channel (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_handler_handle_channel_impl impl = (EMP_SVC_CHANNEL_HANDLER_GET_CLASS (self)->handle_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel_Type,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_handler_implement_handle_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HandleChannel D-Bus method
 *
 * Register an implementation for the HandleChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl)
{
  klass->handle_channel = impl;
}

static inline void
emp_svc_channel_handler_base_init_once (gpointer klass)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.ChannelHandler");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_HANDLER, &interface);

  dbus_g_object_type_install_info (emp_svc_channel_handler_get_type (),
      &_emp_svc_channel_handler_object_info);
}
static void
emp_svc_channel_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_handler_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_handler_methods[] = {
  { (GCallback) emp_svc_channel_handler_handle_channel, _emp_ext_marshal_VOID__STRING_BOXED_STRING_BOXED_UINT_UINT_POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_channel_handler_object_info = {
  0,
  _emp_svc_channel_handler_methods,
  1,
"org.freedesktop.Telepathy.ChannelHandler\0HandleChannel\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel_Type\0I\0s\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_stream_engine_object_info;

struct _EmpSvcStreamEngineClass {
    GTypeInterface parent_class;
    emp_svc_stream_engine_set_output_volume_impl set_output_volume;
    emp_svc_stream_engine_mute_input_impl mute_input;
    emp_svc_stream_engine_mute_output_impl mute_output;
    emp_svc_stream_engine_set_output_window_impl set_output_window;
    emp_svc_stream_engine_add_preview_window_impl add_preview_window;
    emp_svc_stream_engine_remove_preview_window_impl remove_preview_window;
    emp_svc_stream_engine_shutdown_impl shutdown;
};

enum {
    SIGNAL_STREAM_ENGINE_Receiving,
    SIGNAL_STREAM_ENGINE_StreamStateChanged,
    N_STREAM_ENGINE_SIGNALS
};
static guint stream_engine_signals[N_STREAM_ENGINE_SIGNALS] = {0};

static void emp_svc_stream_engine_base_init (gpointer klass);

GType
emp_svc_stream_engine_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcStreamEngineClass),
        emp_svc_stream_engine_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcStreamEngine", &info, 0);
    }

  return type;
}

/**
 * emp_svc_stream_engine_set_output_volume_impl:
 * @self: The object implementing this interface
 * @in_channel_path: const gchar * (FIXME, generate documentation)
 * @in_stream_id: guint  (FIXME, generate documentation)
 * @in_volume: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetOutputVolume on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_set_output_volume (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_volume,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_set_output_volume_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->set_output_volume);

  if (impl != NULL)
    {
      (impl) (self,
        in_channel_path,
        in_stream_id,
        in_volume,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_set_output_volume:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetOutputVolume D-Bus method
 *
 * Register an implementation for the SetOutputVolume method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_set_output_volume (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_set_output_volume_impl impl)
{
  klass->set_output_volume = impl;
}

/**
 * emp_svc_stream_engine_mute_input_impl:
 * @self: The object implementing this interface
 * @in_channel_path: const gchar * (FIXME, generate documentation)
 * @in_stream_id: guint  (FIXME, generate documentation)
 * @in_mute_state: gboolean  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * MuteInput on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_mute_input (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_mute_input_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->mute_input);

  if (impl != NULL)
    {
      (impl) (self,
        in_channel_path,
        in_stream_id,
        in_mute_state,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_mute_input:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the MuteInput D-Bus method
 *
 * Register an implementation for the MuteInput method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_mute_input (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_mute_input_impl impl)
{
  klass->mute_input = impl;
}

/**
 * emp_svc_stream_engine_mute_output_impl:
 * @self: The object implementing this interface
 * @in_channel_path: const gchar * (FIXME, generate documentation)
 * @in_stream_id: guint  (FIXME, generate documentation)
 * @in_mute_state: gboolean  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * MuteOutput on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_mute_output (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_mute_output_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->mute_output);

  if (impl != NULL)
    {
      (impl) (self,
        in_channel_path,
        in_stream_id,
        in_mute_state,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_mute_output:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the MuteOutput D-Bus method
 *
 * Register an implementation for the MuteOutput method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_mute_output (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_mute_output_impl impl)
{
  klass->mute_output = impl;
}

/**
 * emp_svc_stream_engine_set_output_window_impl:
 * @self: The object implementing this interface
 * @in_channel_path: const gchar * (FIXME, generate documentation)
 * @in_stream_id: guint  (FIXME, generate documentation)
 * @in_window: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetOutputWindow on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_set_output_window (EmpSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_window,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_set_output_window_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->set_output_window);

  if (impl != NULL)
    {
      (impl) (self,
        in_channel_path,
        in_stream_id,
        in_window,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_set_output_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetOutputWindow D-Bus method
 *
 * Register an implementation for the SetOutputWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_set_output_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_set_output_window_impl impl)
{
  klass->set_output_window = impl;
}

/**
 * emp_svc_stream_engine_add_preview_window_impl:
 * @self: The object implementing this interface
 * @in_window: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AddPreviewWindow on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_add_preview_window (EmpSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_add_preview_window_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->add_preview_window);

  if (impl != NULL)
    {
      (impl) (self,
        in_window,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_add_preview_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AddPreviewWindow D-Bus method
 *
 * Register an implementation for the AddPreviewWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_add_preview_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_add_preview_window_impl impl)
{
  klass->add_preview_window = impl;
}

/**
 * emp_svc_stream_engine_remove_preview_window_impl:
 * @self: The object implementing this interface
 * @in_window: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RemovePreviewWindow on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_remove_preview_window (EmpSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_remove_preview_window_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->remove_preview_window);

  if (impl != NULL)
    {
      (impl) (self,
        in_window,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_remove_preview_window:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RemovePreviewWindow D-Bus method
 *
 * Register an implementation for the RemovePreviewWindow method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_remove_preview_window (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_remove_preview_window_impl impl)
{
  klass->remove_preview_window = impl;
}

/**
 * emp_svc_stream_engine_shutdown_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Shutdown on interface org.freedesktop.Telepathy.StreamEngine.
 */
static void
emp_svc_stream_engine_shutdown (EmpSvcStreamEngine *self,
    DBusGMethodInvocation *context)
{
  emp_svc_stream_engine_shutdown_impl impl = (EMP_SVC_STREAM_ENGINE_GET_CLASS (self)->shutdown);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_stream_engine_implement_shutdown:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Shutdown D-Bus method
 *
 * Register an implementation for the Shutdown method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_stream_engine_implement_shutdown (EmpSvcStreamEngineClass *klass, emp_svc_stream_engine_shutdown_impl impl)
{
  klass->shutdown = impl;
}

/**
 * emp_svc_stream_engine_emit_receiving:
 * @instance: The object implementing this interface
 * @arg_channel_path: const gchar * (FIXME, generate documentation)
 * @arg_stream_id: guint  (FIXME, generate documentation)
 * @arg_state: gboolean  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Receiving signal on interface org.freedesktop.Telepathy.StreamEngine.
 */
void
emp_svc_stream_engine_emit_receiving (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_STREAM_ENGINE));
  g_signal_emit (instance,
      stream_engine_signals[SIGNAL_STREAM_ENGINE_Receiving],
      0,
      arg_channel_path,
      arg_stream_id,
      arg_state);
}

/**
 * emp_svc_stream_engine_emit_stream_state_changed:
 * @instance: The object implementing this interface
 * @arg_channel_path: const gchar * (FIXME, generate documentation)
 * @arg_stream_id: guint  (FIXME, generate documentation)
 * @arg_state: guint  (FIXME, generate documentation)
 * @arg_direction: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * StreamStateChanged signal on interface org.freedesktop.Telepathy.StreamEngine.
 */
void
emp_svc_stream_engine_emit_stream_state_changed (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    guint arg_state,
    guint arg_direction)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_STREAM_ENGINE));
  g_signal_emit (instance,
      stream_engine_signals[SIGNAL_STREAM_ENGINE_StreamStateChanged],
      0,
      arg_channel_path,
      arg_stream_id,
      arg_state,
      arg_direction);
}

static inline void
emp_svc_stream_engine_base_init_once (gpointer klass)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.StreamEngine");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_STREAM_ENGINE, &interface);

  stream_engine_signals[SIGNAL_STREAM_ENGINE_Receiving] =
  g_signal_new ("receiving",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_UINT_BOOLEAN,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_UINT,
      G_TYPE_BOOLEAN);

  stream_engine_signals[SIGNAL_STREAM_ENGINE_StreamStateChanged] =
  g_signal_new ("stream-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_UINT_UINT_UINT,
      G_TYPE_NONE,
      4,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (emp_svc_stream_engine_get_type (),
      &_emp_svc_stream_engine_object_info);
}
static void
emp_svc_stream_engine_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_stream_engine_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_stream_engine_methods[] = {
  { (GCallback) emp_svc_stream_engine_set_output_volume, _emp_ext_marshal_VOID__BOXED_UINT_UINT_POINTER, 0 },
  { (GCallback) emp_svc_stream_engine_mute_input, _emp_ext_marshal_VOID__BOXED_UINT_BOOLEAN_POINTER, 100 },
  { (GCallback) emp_svc_stream_engine_mute_output, _emp_ext_marshal_VOID__BOXED_UINT_BOOLEAN_POINTER, 198 },
  { (GCallback) emp_svc_stream_engine_set_output_window, _emp_ext_marshal_VOID__BOXED_UINT_UINT_POINTER, 297 },
  { (GCallback) emp_svc_stream_engine_add_preview_window, g_cclosure_marshal_VOID__UINT_POINTER, 397 },
  { (GCallback) emp_svc_stream_engine_remove_preview_window, g_cclosure_marshal_VOID__UINT_POINTER, 467 },
  { (GCallback) emp_svc_stream_engine_shutdown, g_cclosure_marshal_VOID__POINTER, 540 },
};

static const DBusGObjectInfo _emp_svc_stream_engine_object_info = {
  0,
  _emp_svc_stream_engine_methods,
  7,
"org.freedesktop.Telepathy.StreamEngine\0SetOutputVolume\0A\0channel_path\0I\0o\0stream_id\0I\0u\0volume\0I\0u\0\0org.freedesktop.Telepathy.StreamEngine\0MuteInput\0A\0channel_path\0I\0o\0stream_id\0I\0u\0mute_state\0I\0b\0\0org.freedesktop.Telepathy.StreamEngine\0MuteOutput\0A\0channel_path\0I\0o\0stream_id\0I\0u\0mute_state\0I\0b\0\0org.freedesktop.Telepathy.StreamEngine\0SetOutputWindow\0A\0channel_path\0I\0o\0stream_id\0I\0u\0window\0I\0u\0\0org.freedesktop.Telepathy.StreamEngine\0AddPreviewWindow\0A\0window\0I\0u\0\0org.freedesktop.Telepathy.StreamEngine\0RemovePreviewWindow\0A\0window\0I\0u\0\0org.freedesktop.Telepathy.StreamEngine\0Shutdown\0A\0\0\0",
"org.freedesktop.Telepathy.StreamEngine\0Receiving\0org.freedesktop.Telepathy.StreamEngine\0StreamStateChanged\0\0",
"\0\0",
};


